// based on https://en.wikipedia.org/wiki/Duff%27s_device

#include <stdio.h>

void copy_basic(char* from, char* to, int count) {
    do {
        *to++ = *from++;
    } while (--count > 0);
}

void copy(char* from, char* to, int count) {
    register int n = (count + 7) / 8;
    switch (count % 8) {
    case 0: do { *to++ = *from++;
    case 7:      *to++ = *from++;
    case 6:      *to++ = *from++;
    case 5:      *to++ = *from++;
    case 4:      *to++ = *from++;
    case 3:      *to++ = *from++;
    case 2:      *to++ = *from++;
    case 1:      *to++ = *from++;
            } while (--n > 0);
    }
}

int main() {
    char first[] = {1, 2, 3, 4, 5, 6, 7};
    char second[] = {0, 0, 0, 0, 0, 0, 0};
    copy(first, second, 7);
    printf("%d\n", second[3]);
    return 0;
}
